

#include "pelement.h"
#include "connections.h"

#define bool  cgbbool

void connections::clear()
{
	for(int i=0;i<maxinputs;i++)
	{
		inputs[i]=NULL;
		wates[i]=0.0;
	}
	getptr=0;
}

connections::connections()
{
	clear();
}

connections::~connections()
{
}

bool connections::add(pelement& pe,prob w)
{
	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]==NULL || inputs[i]==&pe)
		{
			inputs[i]=&pe;
			wates[i]=w;
			return true;
		}
	}
	return false;
}

bool connections::subtract(pelement& pe)
{
	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]==&pe)
		{
			inputs[i]=NULL;
			wates[i]=0;
			return true;
		}
	}
	return false;
}

bool connections::change(pelement& pe,prob w)
{
	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]==&pe)
		{
			wates[i]=w;
			return true;
		}
	}
	return false;
}

			

pelement* connections::change(int npe,prob w)
{
	if( npe < 0 || npe >= maxinputs)
		return NULL;
	if(w != notprob ) wates[npe]=w;
	return inputs[npe];
}

prob connections::get()
{
	if(getptr>=maxinputs) return notprob;

	while(inputs[getptr]==NULL)
	{
		getptr++;
		if(getptr>=maxinputs) return notprob;
	}

	getptr++;
	return inputs[getptr-1]->getoutput()*wates[getptr-1];
}
prob& connections::getwate()
{
    static prob noprob;
	noprob=notprob;
	if(getptr>=maxinputs) return noprob;

	while(inputs[getptr]==NULL)
	{
		getptr++;
		if(getptr>=maxinputs) return noprob;
	}

	getptr++;
	return wates[getptr-1];
}

int connections::dump()
{
	cout << "connections::[" << this << "] getptr=" << getptr << "\n";

	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]!=NULL)
			cout << "<" << i << ">{" << inputs[i] << "," << wates[i] 
				 << "} ";
	}
	cout << "\n";
	return 0;
}		


prob connections::netinput()
{
	prob total=0;
	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]!=NULL)
			total+=inputs[i]->getoutput()*wates[i];
	}

	return total;
}		

int connections::count()
{
	int total=0;  //count
	for(int i=0;i<maxinputs;i++)
	{
		if(inputs[i]!=NULL)
			total++;
	}

	return total;
}		


int connections::copywates(connections& con)
{
	int total=0;  //count
	for(int i=0;i<maxinputs;i++)
	{
//		if(inputs[i]!=NULL)
			wates[i]=con.wates[i];
	}

	return total;
}





