/*chris busch
 */

#include "critter.h"


int critter::modfood(int howmuch)
{
  if(howmuch==0)
    {
      howmuch=(int)(posprob(outup*movecosts)+
                    posprob(outdn*movecosts)+
                    posprob(outlt*movecosts)+
                    posprob(outrt*movecosts)+
                    posprob(outeat*eatcosts)+turncosts);
    }
  //cerr << "critter[" << this << "] food=" << food << "-howmuch " << howmuch
  //  << "\n";
  food-=howmuch;
  return howmuch;
}

critter::critter()
{
  food=initialfood;
  age=0;
  outup=outdn=outlt=outrt=outeat=0;
  x=y=0;
}




void critter::senses(prob u,prob d,prob l,prob r,prob h)
{
  brain.putinreset();
  brain.putin(u);
  brain.putin(d);
  brain.putin(l);
  brain.putin(r);
  brain.putin(h);
}

void critter::react(prob& u,prob& d,prob& l,prob& r,prob& h)
{
  brain.getoutreset();
  u=brain.getout();
  d=brain.getout();
  l=brain.getout();
  r=brain.getout();
  h=brain.getout();
}


void critter::mutate(prob chance,prob howmuch)
{
  pelement* pe;
  for(int lyr=1;lyr<brain.maxlayers;lyr++)
    {
      brain.getreset(lyr);
      while((pe=brain.get(lyr))!=NULL)
        {
          pe->inputs.getreset();
          prob *pptr;
          while( *(pptr=&(pe->inputs.getwate()))!= notprob)
            {
              if( random.percent() <= chance ) 
                {       
                  (*pptr)+=random.sign()*random.percent()*howmuch;
                }
            }
        }
    }

}

void critter::suppress(prob howmuch)
{
  if(howmuch<=0) return;
  pelement* pe;
  for(int lyr=1;lyr<brain.maxlayers;lyr++)
    {
      brain.getreset(lyr);
      while((pe=brain.get(lyr))!=NULL)
        {
          pe->inputs.getreset();
          prob *pptr;
          while( *(pptr=&(pe->inputs.getwate()))!= notprob)
            {
              (*pptr)=modprob(*pptr,howmuch);
            }
        }
    }

}

cgbbool critter::save(ofstream& out)
{
  if(out.eof() || out.bad() )
    {
      cerr << "cannot save critter::[" << this << "] to disk\n";
      return false;
    }
  pelement* pe;
  out << "age " << age << "\n";
  out << "food " << food << "\n";
  for(int lyr=1;lyr<brain.maxlayers;lyr++)
    {
      brain.getreset(lyr);
      out << "layer " << lyr << "\n";
      while((pe=brain.get(lyr))!=NULL)
        {
          pe->inputs.getreset();
          prob pp;
          while( (pp=(pe->inputs.getwate()))!= notprob)
            {
              out << pp << " ";
            }
          out << "\n";
        }
    }
  return true;
}

cgbbool critter::load(ifstream& file)
{
  if(file.eof() || file.bad() )
    {
      cerr << "cannot open critter::[" << this << "] to disk\n";
      return false;
    }
  pelement* pe;
  char dummy[100];
  //out << "age " << age << "\n";
  file >> dummy >> age;
  //file << "food " << food << "\n";
  file >> dummy >> food;
  for(int lyr=1;lyr<brain.maxlayers;lyr++)
    {
      brain.getreset(lyr);
      //file << "layer " << lyr << "\n";
      file >> dummy >> dummy;
      while((pe=brain.get(lyr))!=NULL)
        {
          pe->inputs.getreset();
          prob* pp;
          while( *(pp=&(pe->inputs.getwate()))!= notprob)
            {
              file >> (*pp);
            }
          //file << "\n";
        }
    }
  if(file.bad()) return false;
  return true;
}

void critter::dump()
{
  cerr << "critter::[" << this << "] food=" << food 
    << " x=" << x << " y=" << y <<" age=" << age << "\n";
  
  cout << "input wates: ";
  pelement* w;
  for(brain.getreset(brain.inputlayer);
      (w=brain.get(brain.inputlayer))!=NULL;)
    {
      cout << " ( " << w->getoutput() << " )";
    }
  cout << "\n";
  
  

  cout << " outup=" << outup << " outdn=" << outdn 
    << " outlt=" << outlt
      << " outrt=" << outrt
        << " outeat=" << outeat << "\n";
}





//end of file

