/*debughelp.cc
chris busch
version 2.0
		- traps nasty signals, elegantly.
*/

/*
NOTE:
   This part is trully an extra part of the lab, its not required!
*/

//LINUX
typedef void SIG_FUNC_TYP(int);
typedef SIG_FUNC_TYP *SIG_TYP;
//end linux


#include <signal.h>
#include <iostream.h>

#include "debughelp.h"

debughelpt* debughelpt::cur=NULL;


//returns last signal
int& debughelpt::lastsig()
{
	static int lastsig_;
	return lastsig_;
}

static void debughelp_defaulttrap(int sig)
{
	cerr << "This signal was trapped: #" << sig << "\n";
}

//secondary signal trapper
void debughelpt::trappedsig(int sig)
{
	if(programtrapper!=NULL)
		(*programtrapper)(sig);
}

//primary signal trapper
void debughelp_errorhandler(int sig)
{
  if(debughelpt::cur != NULL)
  {
	debughelpt::cur->reinstall();
	debughelpt::cur->trappedsig(sig);	
	debughelpt::cur->sigcount++;
	debughelpt::cur->lastsig()=sig;
  }
}

//installer
void debughelpt::reinstall()
{
	signal(SIGSEGV,(SIG_TYP)&debughelp_errorhandler);
	signal(SIGBUS,(SIG_TYP)&debughelp_errorhandler);
	signal(SIGFPE,(SIG_TYP)&debughelp_errorhandler);
	signal(SIGINT,(SIG_TYP)&debughelp_errorhandler);
	signal(SIGUSR1,(SIG_TYP)&debughelp_errorhandler);
}


//constructor
debughelpt::debughelpt()
{
	oldcur=cur;
	cur=this;
	segvsignalfunc=signal(SIGSEGV,(SIG_TYP)&debughelp_errorhandler);
	bussignalfunc=signal(SIGBUS,(SIG_TYP)&debughelp_errorhandler);
	fpesignalfunc=signal(SIGFPE,(SIG_TYP)&debughelp_errorhandler);
	intsignalfunc=signal(SIGINT,(SIG_TYP)&debughelp_errorhandler);
	usr1signalfunc=signal(SIGUSR1,(SIG_TYP)&debughelp_errorhandler);
	lastsig()=0;
	sigcount=0;
	programtrapper=debughelp_defaulttrap;
}

//destructor
debughelpt::~debughelpt()
{
	signal(SIGSEGV,segvsignalfunc);
    signal(SIGBUS,bussignalfunc);
    signal(SIGFPE,fpesignalfunc);
    signal(SIGINT,intsignalfunc);
    signal(SIGUSR1,usr1signalfunc);
	cur=oldcur;
}

	
//prints status of caught signals
void debughelpt::status()
{
	cout << "Last signal caught was #" << lastsig() << "\n"
		 << "Total caught was " << sigcount << ".\n";

}


	

//end of this file







