//chris busch
//net-life

#include <unistd.h>

ifstream batch;
time_t batchstoptime=0;

char helptext[]=
"A\tset Automatic turns\n"
"l\tload file\n"
"s\tsave file\n"
"h\thelp\n"
"m\tminimum alive\n"
"M\tmax turns\n"
"i\tinformation\n"
"f\tfamine\n"
"F\tfeed\n"
"D\tdump all life\n"
"d\tdump only alive life\n"
"p\tset parameters\n"
"S\tset sprinkle food parameters\n"
"R\tset run food parameters\n"
"B\tset begin round food parameters\n"
"v\tset visual mode\n"
"x\texit this mode\n"
"q\tquit this program\n"
"X\tchange dimensions\n"
"b\tbirth parameters\n";


int yesorno(char question[]="[y/n]? ")
{
  char ch;
  char kb[10]="";
  do{
    cout << question << flush;
    fflush(stdin);
    fgets(kb,9,stdin);
    ch=kb[0];
    fflush(stdin);
  }while(!(ch=='y' || ch=='n'));
  if(ch=='n') return 0;
  return 1;
}


void saveit()
{
  char fname[100],title[100];
  cout << "enter: file-name title ";
  cin >> fname >> title;
  if(!earth.save(fname,title))
    cerr << "the file " << fname << " had an ERROR!\n";
  else
    cerr << "the file " << fname << " did save correctly.\n";
}

void loadit()
{
  char fname[100];
  cout << "enter: file-name ";
  cin >> fname;
  if(!earth.load(fname))
    cerr << "the file " << fname << " had an ERROR!\n";
  else
    cerr << "the file " << fname << " did load correctly.\n";
  tlog << "load file " << fname << "\n";
}


double getparam(char prompt[],double oldval)
{
  fflush(stdin);
  if(oldval != 0)
    cout << "Former value was (" << oldval << "). ";

  double tmp; 
  do{    //STDIO
    fflush(stdin);
    cout << "\n" <<  prompt << flush;
  }while(!scanf("%lf",&tmp));
  fflush(stdin);
  return tmp;
}

int getparam(char prompt[],int oldval)
{
  fflush(stdin);
  if(oldval != 0)
    cout << "Former value was (" << oldval << "). ";


  int tmp;
  do{ //STDIO
    fflush(stdin);
    cout << "\n" <<  prompt << flush;
  }while(!scanf("%d",&tmp));
  fflush(stdin);
  return tmp;
}

int menuoptions(int option)
{
  cout << "\n";
  switch(option)
    {
    case 10:
    case 13:
      option=0;
      break;
    case 0:
      cout << "\nPress <space> and <enter> to continue simulation.\n";
      option=-1;
      break;
    case ' ':
      option=0;
      break;
    case 'L':
      {
        cout << "please enter new log file name: ";
        char logfname[100];
        cin >> logfname;
        openlogfile(logfname);
      }
      break;
    case 'A':
      automatic=getparam("how many automatic turns? ",0);
      break;
    case 'l':
      loadit();
      break;
    case 's':
      saveit();
      break;
    case 'h':
      cout << "\nhelp:\n" << helptext << "\n";
      break;
    case 'm':
      minalive=getparam("new min-alive: ",minalive);
      break;
    case 'M':
      maxturns=getparam("max turns: ",maxturns);
      break;
    case 'i'://info
      cout << "Number alive: " << earth.numalive << "\n";
      break;
	case 12: //control L
    case 'r': //repaint
    case 'c': //cls
      cout << "\nrepainting/cls...";
      break;
    case 'b': //birth parameters
      earth.mutnewchance=getparam("new mutation chance: ",earth.mutnewchance);
      earth.mutnewamount=getparam("new mutation amount: ",earth.mutnewamount);
      earth.mutdupchance=getparam("dup mutation chance: ",earth.mutdupchance);
      earth.mutdupamount=getparam("dup mutation amount: ",earth.mutdupamount);
      earth.suppressamount=
	getparam("suppression amount: (0=none) ",earth.suppressamount);
      break;
    case 'f'://famine
      earth.famine(getparam("famine! enter probability: ",0.0));
      break;
    case 'F'://FOOD!
      earth.fillwithfood(getparam("FEED quality: ",0),
                         getparam("FEED probabilty: ",0.0));
      break;
    case 'D': //dump info
      earth.dump();     
      break;
    case 'd':
      earth.dump(0);
      break;
    case 'p': //parameters
      earth.sfparam.put(earth.foodrange,
                        getparam("enter sprinkle-food quantity: "
                                 ,earth.sfparam.quantity),
                        getparam("enter sprinkle-food chance: "
                                 ,earth.sfparam.chance));
      earth.rwfparam.put(earth.foodrange,
                         getparam("enter run-food quantity: "
                                  ,earth.rwfparam.quantity),
                         getparam("enter run-food chance: "
                                  ,earth.rwfparam.chance));
      earth.fwfparam.put(
                         earth.foodrange,0
                         ,getparam("enter begin-round-food chance: "
                                   ,earth.fwfparam.chance));
      break;
    case 'S':
      earth.sfparam.put(earth.foodrange,
                        getparam("enter sprinkle-food quantity: "
                                 ,earth.sfparam.quantity),
                        getparam("enter sprinkle-food chance: "
                                 ,earth.sfparam.chance));
      break;
    case 'R':
      earth.rwfparam.put(earth.foodrange,
                         getparam("enter run-food quantity: "
                                  ,earth.rwfparam.quantity),
                         getparam("enter run-food chance: "
                                  ,earth.rwfparam.chance));
      break;
    case 'B':
      earth.fwfparam.put(
                         earth.foodrange,0
                         ,getparam("enter begin-round-food chance: "
                                   ,earth.fwfparam.chance));
      break;
    case 'v':
      visual=yesorno("\nRun visually? [y/n] ");
      break;
    case 'q':
      option=(yesorno("\nReally quit? ") ? (automatic=0,'q') : 0);
      break;
    case 'x':
      option=(yesorno("\nReally exit? ") ? (automatic=0,'q') : 0);
      break;
    case 'X':
      earth.resizescreen(getparam("enter row size: ",earth.maxrow),
                         getparam("enter column size: ",earth.maxcol));
      break;
    default:
      cout << "\nUnknown option, press h for help\n";
      option= -option;
    }
  return option;  
}

int textmenu()
{
  char input[20]; int ret;
  do{
    cout << "Menu: ";
    fgets(input,19,stdin);
    ret=menuoptions(input[0]);
  }while(ret!='q' && ret!=0);
  return ret;
}

int visualmenu(int option=0)
{
  if(option<' ' && option!=12) return option;
  //12 is control L

  sio.uninitkey();
  sio.uninit();

  fflush(stdin);

  if(option==' ') {
    char dumstr[10]="";
    cout << "Menu: ";
    cin.getline(dumstr,9);
    option=dumstr[0];   
  }

  option=menuoptions(option);
  
  fflush(stdin);
#ifdef __linux__
  cout << "please wait...\n" << flush;
  //  sleep(2);
#endif
  cout << "\npress <return>\n" << flush;;
  char junkbuf[10];
  fgets(junkbuf,9,stdin);
  sio.init();
  sio.initkey();
  sio.repaint();
  
  return option;
}


int runvisual()
{
  sio.init();
  sio.initkey();
  sio.repaint();

  do{
    earth.runwithfood();
    earth.sprinklefood();
    earth.runturn();
    
  }while((visualmenu(sio.getkey())!='q') && 
         maxturns>earth.turns && earth.numalive>minalive && visual);

  sio.uninitkey();
  sio.uninit();

  fflush(stdin);
  return 0;
}


int runtextual()
{
  do{
    earth.runwithfood();
    earth.sprinklefood();
    earth.runturn();
    if(earth.turns%10==0) cout << '.' << flush;
  } while(maxturns>earth.turns && earth.numalive>minalive);

  return 0;
}


int runany()
{
  while((automatic>0 || textmenu()!='q'))
    {
      cout << "beginning round " << earth.nextround() << flush;
      earth.fillwithfood();

      earth.visual=(cgbbool) visual;
      if(visual)
        runvisual();
      else
        runtextual();
      if(automatic>0) automatic--;

      cout << "\nround: " << earth.round 
        << " turns ran: " << earth.turns <<  " alive: " 
          << earth.numalive << "\n";

      tlog << "time(" << time(NULL) << ") round: " << earth.round 
        << " turns ran: " << earth.turns <<  " alive: " 
          << earth.numalive << "\n" << flush;

      earth.repop(1);

    }
  return 0;
}




int batchoptions()
{
  char str1[100]="",str2[100]="";
  int i1=0,i2=0;
  prob f1=0.0;
  char option=0;

  char s[100]="";
  batch >> s;

  option=s[0];

  switch(option)
    {
    case 0:
      tlog << "_\n";
      break;
    case 'T':
      batch >> i1;
      batchstoptime=time(NULL)+i1;
      tlog << "stop in seconds: " << i1 << "\n";
      break;
    case 'L':
      batch >> str1;
      tlog.close();
      openlogfile(str1);
      tlog << "logfile " << str1 << "\n";
      break;
    case 'A':
      batch >> automatic;
      tlog << "auto " << automatic << "\n";
      break;
    case 'l':
      batch >> str1;
      earth.load(str1);
      tlog << "load from " << str1 << "\n";
      break;
    case 's':
      batch >> str1 >> str2;
      earth.save(str1,str2);
      tlog << "save to " << str1 << "\n";
      break;
    case 'h':
      tlog << "\nhelp:\n" << helptext << "\n";
      break;
    case 'm':
      batch >> minalive;
      tlog << "maxturns " << minalive << "\n";
      break;
    case 'M':
      batch >> maxturns;
      tlog << "maxturns " << maxturns << "\n";
      break;
    case 'i'://info
      tlog << "Number alive: " << earth.numalive << "\n";
      break;
    case 'f'://famine
      batch >> f1;
      earth.famine(f1);
      tlog << "famine " << f1 << "\n";
      break;
    case 'F'://FOOD!
      batch >> i1 >> f1;
      earth.fillwithfood(i1,f1);
      tlog << "FEED " << i1 << " " << f1 << "\n";
      break;
    case 'D': //dump info
      earth.dump();     
      tlog << "dump.\n";
      break;
    case 'd':
      earth.dump(0);
      tlog << "dump.\n";
      break;
    case 'b': //birth parameters
      batch >> earth.mutnewchance >> earth.mutnewamount
	>> earth.mutdupchance >> earth.mutdupamount 
	  >> earth.suppressamount;
      tlog << "birth parameters " << earth.mutnewchance << " " 
	<< earth.mutnewamount << " " << earth.mutdupchance << " "
	  << earth.mutdupamount << " " << earth.suppressamount << "\n";
      break;
    case 'p': //parameters
      tlog << "parameters not supported in batch\n";
      break;
    case 'S':
      batch >> i1 >> f1;
      earth.sfparam.put(earth.foodrange,i1,f1);
      tlog << "sprinkle-food " << i1 << " " << f1 << "\n";
      break;
    case 'R':
      batch >> i1 >> f1;
      earth.rwfparam.put(earth.foodrange,i1,f1);
      tlog << "run-with-food " << i1 << " " << f1 << "\n";
      break;
    case 'B':
      batch >> f1;
      earth.fwfparam.put(earth.foodrange,0,f1);
      tlog << "begin-round-food " << f1 << "\n";
      break;
    case 'v':
      break;
    case 'q':
      break;
    case 'X':
      batch >> i1 >> i2;
      earth.resizescreen(i1,i2);
      tlog << "resized to " << i1 << " " << i2 << "\n";
      break;
    default:
      tlog << "\nUnknown option '" << option << "'\n";
      option= -option;
    }
  /*  cout << "s='" << s << "' option='" << option  << "' (i i f s s) "
      <<        i1 << " " << 12 << " " << f1 << " '" << str1 << "' '" << str2 <<
      "'\n"
      << flush;
      */
  return option;  
}


int runbatch(char *fname)
{
  batchstoptime=0;
  visual=0;
  earth.visual=false;

  batch.open(fname,ios::in);
  if(! batch.good() || batch.bad())
    {
      cerr << "batch file name " << fname << " cannot be read!\n";
      return 0;
    }
  while(!batch.eof())
    {
      visual=0;
      earth.visual=false;
      batchoptions();
      if(batchstoptime && (batchstoptime<time(NULL)))
        {
          tlog << "batch time limit exceeded.\n";
          return 0;
        }
      while(automatic>0)
        {
          tlog << "beginning round " << earth.nextround() << flush;
          earth.fillwithfood();
          
          
          do{
            earth.runwithfood();
            earth.sprinklefood();
            earth.runturn();
            if(earth.turns%10==0) tlog << '.' << flush;
          } while(maxturns>earth.turns && earth.numalive>minalive);
          
          if(automatic>0) automatic--;
          
		  if(verbosebatch)
			cout << "\nround: " << earth.round 
			  << " turns ran: " << earth.turns <<  " alive: " 
				<< earth.numalive << "\n" << flush;
        
          tlog << "\ntime(" << time(NULL) << ") round: " << earth.round 
            << " turns ran: " << earth.turns <<  " alive: " 
              << earth.numalive << "\n" << flush;
          
          earth.repop(1);
          
        }
    }
  cout << "done\n";
  return 0;
}

//eof







