/*chris busch

*/


#ifndef WORLD_H
#define WORLD_H

#include "screenio.h"

#include "prob.h"
#include "critter.h"



 
class world
{
public:
	enum {Version=2};
	enum {blank=' '};
	int maxrow,maxcol;
	enum {begfood='\'',endfood='\''+9,
		 foodrange=endfood-begfood+1,foodworthdef=1000};
	enum {begdude='A',enddude='Z',
		 duderange=enddude-begdude+1,
		 dudecoloroffset1=30,traildef=' ',death='*'};

	int foodworth;
	char trail;	
	
	struct feedparam
	{
		int quality,quantity;
		prob chance;

		feedparam() { put(foodrange,5,1.0); }
		void put(int x,int y,prob c) { quality=x;quantity=y;chance=c; }
	};
	
	feedparam fwfparam,rwfparam,sfparam;
	
	prob mutnewchance,mutnewamount
	  ,mutdupchance,mutdupamount
	    ,suppressamount;

private:
	char* mapdata; //maxrow , maxcol
	char& map(int y,int x) { return mapdata[y*maxcol+x]; }
	
    time_t starttime;	
   
public:

#ifdef MAXDUDES
	enum {maxdudes=MAXDUDES};
#else 
	enum {maxdudes=300};
#endif
	cgbbool visual;
	int turns,round,numalive;
	
	critter dudes[maxdudes];

	int clear();  //clears this object not screen!
	int resizescreen(int row=sio.ysize()-2,int col=sio.xsize());

	world();

	void init();
	
	void repop(int);

	int nextround() { starttime=time(NULL); return ++round; }		

	int domoves();	
	void nextmove(critter&);
	int imagefunc(critter&);
	void draw();

	
	int isfood(char c);
	int foodstrength(int y,int x);		 //actual amount of food
	prob foodpower(int y,int x);  //a 0to1 range in area

	int sprinklefood(int,int,prob=1.0);  //howmany and howmuch,chance

	int sprinklefood()
	{ return sprinklefood(sfparam.quantity,sfparam.quality,sfparam.chance); }
  
	int runwithfood(int,int,prob=1.0);  //howmany and howmuch,chance
	int runwithfood()
	{ return runwithfood(rwfparam.quantity,rwfparam.quality,rwfparam.chance); }

	int fillwithfood(int,prob);

	int fillwithfood()
	{ return fillwithfood(fwfparam.quality,fwfparam.chance); }

	int famine(prob p=1.0)
	{ return fillwithfood(-1,p); }



	int doeat(critter&);

	char convert(char c) { return c==0 ? blank : c;}

	
	int wrapcol(int);
	int wraprow(int);
	char& look(int r,int c) 
	{ return map(wraprow(r),wrapcol(c));}

	int runturn();

	void dump(int=-1);

	cgbbool save(char[],char[]="earth");
	cgbbool load(char[]);
};



#endif
//this file




